// pages/pointDetail/pointDetail.js
const app = getApp()
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')

wxService.page({

  /**
   * 页面的初始数据
   */
  data: {
    imgHeight: 450,
    dialog: {
      show: false,
      image: '../../assets/imgs/point/bgc.png',
      content: '优惠券和积分流水',
      tip: '立即查看'
    },
    desc: [{ "label": "优惠详情", "value": "使用100积分可兑换一张维记鲜牛奶优惠券，凭券可以4.8元优惠价换购维记鲜牛奶236ML一盒！", "type": 2 }, { "label": "有效时间", "value": "2019-07-12 至 2019-08-06", "type": 2 }, { "label": "兑换说明", "value": "1、点击【立即兑换】，即可兑换成功，每人限兑换10张券\n2、在【会员小程序-优惠券】中可查询到已兑换的券；", "type": 2 }, { "label": "使用须知", "value": "1、凭此优惠券，前往广东7-Eleven有售门店，可以优惠价4.8元换购维记鲜牛奶236ML一盒！2、成功领到优惠券后，请务必在有效期内使用，逾期无效；3、一张券限兑换维记鲜牛奶236ML一盒；4、优惠券不设找零、不可兑换现金； 5、请于交易前向收银员出示此优惠券； 6、使用优惠券发生的交易，广东7-Eleven仅按实际支付金额开具发票；7、如发生退货，仅按顾客实际支付金额退款。 ", "type": 2 }],
    activityId: '',
    type: 1, // 1 订单 2 商品
    popupType: 0, // 默认不跳转  1 优惠券 2 积分
    goal: 0,
    detailImage: '',
    countObj: null,
    currentPercent: 0 // 当前进度
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },
  //  集点详情
  getPointDetail(id) {
    wx.showLoading({
      title: '加载中'
    })
    wxService.get(`/sale/touchpoints/pointConsumptionActivity/findById/${id} `).then(res => {
      if (res) {
        const { result, data } = res.data
        if (result == 0) {
          wx.hideLoading()
          let dialog = this.data.dialog
          //  popupType: 0  1 优惠券 2 积分
          if(data.popupType == 1){
            dialog.content = '优惠券'
          } else if(data.popupType == 2) {
            dialog.content = '积分流水'
          }
          this.setData({
            activityId: data.id,
            type: data.type,
            popupType: data.popupType,
            goal: data.goal,
            detailImage: data.detailImage,
            dialog
          }, () => {
            // 会员集点活动统计信息
            this.getPointConsumptionCount(id)
          })
        }
      }
    })
  },
  // 会员集点活动统计信息
  getPointConsumptionCount(activityId) {
    const { memberId } = wx.getStorageSync('_baseUserInfo')
    wx.showLoading({
      title: '加载中'
    })
    wxService.post(`/sale/touchpoints/pointConsumptionCount/getPointConsumptionCount?activityId=${activityId}&memberId=${memberId}`).then(res => {
      if (res) {
        const { result, data } = res.data
        if (result == 0) {
          wx.hideLoading()
          this.setData({
            countObj: data,
            // currentPercent: (100 / 5) * 2
            currentPercent: (100 / this.data.goal) * data.surplusPoints
          })
        }
      }
    })
  },
  handleCheckGoods() {
    const { activityId }  = this.data
    wxService.router(`/subPackage/page/pages/pointGoodsList/pointGoodsList`).search({ activityId})
  },
  handleGo() {
    // 兑换成功跳转
    this.getPointExchange()

  },
  //  触点有礼-消费集点兑换
  getPointExchange() {
    const { activityId } = this.data
    const { memberId } = wx.getStorageSync('_baseUserInfo')
    wx.showLoading({
      title: '加载中'
    })
    wxService.get(`/sale/touchpoints/pointConsumptionExchange/exchange?activityId=${activityId}&memberId=${memberId}`).then(res => {
      if (res) {
        const { result, data } = res.data
        if (result == 0) {
          wx.hideLoading()
          // 跳转  popupType: 0  默认不跳转  1 优惠券 2 积分
          const { popupType } = this.data
          if (popupType == 1) {
            wxService.router(`/pages/coupons/coupons`)
          } else if (popupType == 2) {
            wxService.router(`/pages/integralWater/integralWater`)
          }
        }
      }
    })
  },
  handleToGet() {
    let dialog = this.data.dialog
    dialog.show = true
    this.setData({
      dialog
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    const { id } = this.options
    if (id) {
      this.getPointDetail(id)
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})